// Sample9Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Sample9.h"
#include "Sample9Dlg.h"
#include "ImportApiEx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSample9Dlg dialog


////////////////////////////////////////////////        
//Mounting EmuPrinterAPI  
////////////////////////////////////////////////
CEmuPrinterAPI	EmuPrinterAPI;
int hHdl;		//Printer Control Handle
DWORD hst;		//save status


CSample9Dlg::CSample9Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSample9Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSample9Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSample9Dlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDPrint, &CSample9Dlg::OnBnClickedPrint)
	ON_BN_CLICKED(IDPrinterReset, &CSample9Dlg::OnBnClickedPrinterreset)
	ON_BN_CLICKED(IDCallBack, &CSample9Dlg::OnBnClickedCallback)
	ON_BN_CLICKED(IDCallBack2, &CSample9Dlg::OnBnClickedCallback2)
	ON_BN_CLICKED(IDMessage, &CSample9Dlg::OnBnClickedMessage)
	ON_BN_CLICKED(IDC_BUTTON1, &CSample9Dlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDMessage2, &CSample9Dlg::OnBnClickedMessage2)
	ON_BN_CLICKED(IDStatus, &CSample9Dlg::OnBnClickedStatus)
END_MESSAGE_MAP()


// CSample9Dlg message handlers

BOOL CSample9Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	if ( EmuPrinterAPI.Initialize() == FALSE ) 
	{
		AfxMessageBox(_T("Error :Load PrinterAPI"));
		return FALSE;
	}


	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSample9Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSample9Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CSample9Dlg::OnBnClickedPrint()
{
int hHdl;		//Printer Control Handle
int ret;

BYTE cmd[14];
BYTE hst[255];
BYTE hsize = 255;

	cmd[0] = 'H';
	cmd[1] = 'e';
	cmd[2] = 'l';
	cmd[3] = 'l';
	cmd[4] = 'o';
	cmd[5] = ' ';
	cmd[6] = 'P';
	cmd[7] = 'r';
	cmd[8] = 'i';
	cmd[9] = 'n';
	cmd[10] = 't';
	cmd[11] = 'e';
	cmd[12] = 'r';
	cmd[13] = 0x0A;
	//!!!! EiOpenMonPrinteȓ2͊eňقȂ܂
	hHdl = EmuPrinterAPI.EiOpenMonPrinter(2,"NII IPD NP-T318");
	if(hHdl < SUCCESS)
	{
		AfxMessageBox(_T("Error: EiOpenMonPrinter"));
	}
	ret = EmuPrinterAPI.EiDirectIO(hHdl,14,cmd,&hsize,hst,1000,TRUE);
	if(ret != SUCCESS)
	{
		AfxMessageBox(_T("Error: EiDirectIO"));
	}
	 EmuPrinterAPI.EiCloseMonPrinter(hHdl);
}

void CSample9Dlg::OnBnClickedPrinterreset()
{
int hHdl;		//Printer Control Handle
int ret;

	//!!!! NiiDPrint̑2͊eňقȂ܂
	hHdl = EmuPrinterAPI.EiOpenMonPrinter(2,"NII IPD NP-T318");
	if(hHdl < SUCCESS)
	{
		AfxMessageBox(_T("Error: EiOpenMonPrinter"));
	}
	ret = EmuPrinterAPI.EiResetPrinter(hHdl);
	if(ret != SUCCESS)
	{
		AfxMessageBox(_T("Error: EiDirectIO"));
	}
	EmuPrinterAPI.EiCloseMonPrinter(hHdl);
}

//Xe[^XCxgpR[obN֐
int CALLBACK StatusCB(DWORD st)
{
	if ( st & ESB_NO_RESPONSE ) 
	{
		AfxMessageBox(_T("CB->v^̉܂B"));
	}

	// Cover Open
	if ( st & ESB_COVER_OPEN ) 
	{
		AfxMessageBox(_T("CB->Jo[JĂ܂."));
	}
		
	// Cut Error
	if ( st & ESB_AUTOCUTTER_ERR ) 
	{
		AfxMessageBox(_T("CB->JbgG[܂."));
	}

	// Paper Near End
	if ( st & ESB_RECEIPT_NEAR_END ) 
	{
		AfxMessageBox(_T("CB->[ȂȂ܂."));
	}

	// Paper End
	if ( st & ESB_RECEIPT_END ) 
	{
		AfxMessageBox(_T("CB->[ȂȂ܂."));
	}

	// Ready
	if ( st == 0 ) 
	{
		AfxMessageBox(_T("CB->v^ɂȂ܂."));
	}

	return(0);
}

void CSample9Dlg::OnBnClickedCallback()
{
int ret;

	//!!!! NiiDPrint̑2͊eňقȂ܂
	hHdl = EmuPrinterAPI.EiOpenMonPrinter(2,"NII IPD NP-T318");
	if(hHdl < SUCCESS)
	{
		AfxMessageBox(_T("Error: EiOpenMonPrinter"));
	}
	ret = EmuPrinterAPI.EiSetStatusBackFunction(hHdl,&StatusCB);
	if(ret < SUCCESS)
	{
		AfxMessageBox(_T("Error: EiSetStatusBackFunction"));
	}
	else
	{
		AfxMessageBox(_T("Success: EiSetStatusBackFunction"));	
	}

}

void CSample9Dlg::OnBnClickedCallback2()
{
int ret;
	ret = EmuPrinterAPI.EiCancelStatusBack(hHdl);
	if(ret != SUCCESS)
	{
		AfxMessageBox(_T("Error: EiCancelStatusBack"));
	}
	else
	{
		AfxMessageBox(_T("Success: EiCancelStatusBack"));	
	}
	EmuPrinterAPI.EiCloseMonPrinter(hHdl);
}

void CSample9Dlg::OnBnClickedButton1()
{
	if ( hst & ESB_NO_RESPONSE ) 
	{
		AfxMessageBox(_T("Msg->v^̉܂B"));
	}

	// Cover Open
	if ( hst & ESB_COVER_OPEN ) 
	{
		AfxMessageBox(_T("Msg->Jo[JĂ܂."));
	}
		
	// Cut Error
	if ( hst & ESB_AUTOCUTTER_ERR ) 
	{
		AfxMessageBox(_T("Msg->JbgG[܂."));
	}

	// Paper Near End
	if ( hst & ESB_RECEIPT_NEAR_END ) 
	{
		AfxMessageBox(_T("Msg->[ȂȂ܂."));
	}

	// Paper End
	if ( hst & ESB_RECEIPT_END ) 
	{
		AfxMessageBox(_T("Msg->[ȂȂ܂."));
	}

	// Ready
	if ( hst == 0 ) 
	{
		AfxMessageBox(_T("Msg->v^ɂȂ܂."));
	}
}

void CSample9Dlg::OnBnClickedMessage()
{
int ret;
HWND hwnd;

	hwnd = ::GetDlgItem(this->m_hWnd,IDC_BUTTON1) ;

	//!!!! NiiDPrint̑2͊eňقȂ܂
	hHdl = EmuPrinterAPI.EiOpenMonPrinter(2,"NII IPD NP-T318");
	if(hHdl < SUCCESS)
	{
		AfxMessageBox(_T("Error: EiOpenMonPrinter"));
	}
	ret = EmuPrinterAPI.EiSetStatusBackWnd(hHdl, hwnd ,&hst);
	if(ret < SUCCESS)
	{
		AfxMessageBox(_T("Error: EiSetStatusBackWnd"));
	}
	else
	{
		AfxMessageBox(_T("Success: EiSetStatusBackWnd"));	
	}
}


void CSample9Dlg::OnBnClickedMessage2()
{
int ret;
	ret = EmuPrinterAPI.EiCancelStatusBack(hHdl);
	if(ret != SUCCESS)
	{
		AfxMessageBox(_T("Error: EiCancelStatusBack"));
	}
	else
	{
		AfxMessageBox(_T("Success: EiCancelStatusBack"));	
	}
	EmuPrinterAPI.EiCloseMonPrinter(hHdl);
}

void CSample9Dlg::OnBnClickedStatus()
{
int ret;
DWORD st;

int hHdl;		//Printer Control Handle

	//!!!! NiiDPrint̑2͊eňقȂ܂
	hHdl = EmuPrinterAPI.EiOpenMonPrinter(2,"NII IPD NP-T318");
	if(hHdl < SUCCESS)
	{
		AfxMessageBox(_T("Error: EiOpenMonPrinter"));
	}

	ret = EmuPrinterAPI.EiGetStatus(hHdl,&st);
	if(ret < SUCCESS)
	{
		AfxMessageBox(_T("Error: EiGetStatus"));
	}
	else
	{
		AfxMessageBox(_T("Success: EiGetStatus"));	
		// No Response
		if ( st & ESB_NO_RESPONSE ) 
		{
			AfxMessageBox(_T("v^̉܂B"));
		}

		// Cover Open
		if ( st & ESB_COVER_OPEN ) 
		{
			AfxMessageBox(_T("Jo[JĂ܂."));
		}
		
		// Cut Error
		if ( st & ESB_AUTOCUTTER_ERR ) 
		{
			AfxMessageBox(_T("JbgG[܂."));
		}

		// Paper Near End
		if ( st & ESB_RECEIPT_NEAR_END ) 
		{
			AfxMessageBox(_T("[ȂȂ܂."));
		}
		// Paper End
		if ( st & ESB_RECEIPT_END ) 
		{
			AfxMessageBox(_T("[ȂȂ܂."));
		}
	}
	EmuPrinterAPI.EiCloseMonPrinter(hHdl);
}
