Public Class Form1

    Dim nii As New NiiPrinterCLib.NIIClassLib()

    'NiiStartDoc
    Private Sub Command4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Command4.Click
        Dim ret As Integer
        Dim jid As Long

        ret = nii.NiiStartDoc(Text8.Text, jid)
        If ret <> 0 Then
            MessageBox.Show("Error")
        End If
        Text5.Text = Convert.ToString(jid)
    End Sub

    'NiiEndDoc
    Private Sub Command5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Command5.Click
        Dim ret As Integer

        ret = nii.NiiEndDoc(Text8.Text)
        If ret <> 0 Then
            MessageBox.Show("Error")
        End If
    End Sub

    'NiiPrint
    Private Sub Command1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Command1.Click
        Dim ret As Integer
        Dim jid As Long

        ret = nii.NiiPrint(Text8.Text, Text1.Text, Text1.Text.Length, jid)
        If (ret < 0) Then
            MessageBox.Show("Error")
        End If
        Text5.Text = Convert.ToString(jid)
    End Sub

    'NiiImagePrint
    Private Sub Command2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Command2.Click
        Dim ret As Integer
        Dim jid As Long
        Dim hdc As IntPtr
        Dim g As Graphics

        'foCXReLXg(HDC)擾
        g = Picture1.CreateGraphics()
        g.DrawImage(Picture1.Image, 0, 0, Picture1.Image.Width, Picture1.Image.Height)
        hdc = g.GetHdc()

        'C[Wo(FILE)
        ret = nii.NiiImagePrint(Text8.Text, hdc, Picture1.Image.Width, Picture1.Image.Height, True, jid)
        If ret <> 0 Then
            MessageBox.Show("Error")
        End If
        Text5.Text = Convert.ToString(jid)

        'C[Wo(LINE)
        ret = nii.NiiImagePrint(Text8.Text, hdc, Picture1.Image.Width, Picture1.Image.Height, False, jid)
        If ret <> 0 Then
            MessageBox.Show("Error")
        End If
        Text5.Text = Convert.ToString(jid)

        'C[Wo(BIT)
        ret = nii.NiiBitImagePrint(Text8.Text, hdc, Picture1.Image.Width, Picture1.Image.Height, jid)
        If ret <> 0 Then
            MessageBox.Show("Error")
        End If
        Text5.Text = Convert.ToString(jid)

        '\[XJ
        g.ReleaseHdc(hdc)
        g.Dispose()
    End Sub

    'NiiGetStatus
    Private Sub Command3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Command3.Click
        Dim st As Long
        Dim ret As Integer

        ret = nii.NiiGetStatus(Text8.Text, st)
        If ret <> 0 Then
            MessageBox.Show("Error")
        End If
        Text2.Text = Convert.ToString(st)
    End Sub

    'NiiGetInfomation <ID=2>
    Private Sub Command6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Command6.Click
        Dim i As Integer
        Dim tm As Long
        Dim ret As Integer
        Dim dat(64) As Byte

        ret = nii.NiiGetInformation(Text8.Text, 2, dat, tm)
        If ret <> 0 Then
            MessageBox.Show("Error")
        End If

        'Model&Time
        Text3.Text = ""
        For i = 0 To 63
            Text3.Text = Text3.Text + Chr(dat(i))
        Next
        Text4.Text = Convert.ToString(tm)
    End Sub

    'NiiGetInfomation <ID=19>
    Private Sub Command9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Command9.Click
        Dim i As Integer
        Dim tm As Long
        Dim ret As Integer
        Dim dat(64) As Byte

        ret = nii.NiiGetInformation(Text8.Text, 19, dat, tm)
        If ret <> 0 Then
            MessageBox.Show("Error")
        End If

        Text9.Text = ""
        Text7.Text = ""
        Text9.Text = Convert.ToString(BitConverter.ToUInt32(dat, 0))
        For i = 4 To 7
            Text7.Text = Text7.Text + dat(i).ToString("X2")
        Next
        Text6.Text = Convert.ToString(tm)

    End Sub

    Private Sub Command7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Command7.Click
        Dim ret As Integer
        Dim cmd As Integer
        Dim jid As Long
        Dim wk As String
        Dim hdc As IntPtr
        Dim g As Graphics

        'foCXReLXg(HDC)擾
        g = Picture1.CreateGraphics()
        g.DrawImage(Picture1.Image, 0, 0, Picture1.Image.Width, Picture1.Image.Height)
        hdc = g.GetHdc()

        ret = nii.NiiStartDoc(Text8.Text, jid)
        If ret <> 0 Then
            MessageBox.Show("Error")
        End If
        Text5.Text = Convert.ToString(jid)
        '󎚊Jn錾
        cmd = jid
        wk = "1D""G""11" + cmd.ToString("X2") + "000000"
        ret = nii.NiiPrint(Text8.Text, wk, wk.Length, Nothing)
        If ret <> 0 Then
            MessageBox.Show("Error")
        End If
        '󎚑O
        wk = "1B""@""1B4AFF1D7E801B6101"
        ret = nii.NiiPrint(Text8.Text, wk, wk.Length, Nothing)
        If ret <> 0 Then
            MessageBox.Show("Error")
        End If
        'hLgC[Wo
        wk = """TEST Image START""0a"
        ret = nii.NiiPrint(Text8.Text, wk, wk.Length, Nothing)
        If ret <> 0 Then
            MessageBox.Show("Error")
        End If
        ret = nii.NiiImagePrint(Text8.Text, hdc, Picture1.Image.Width, Picture1.Image.Height, True, Nothing)
        If ret <> 0 Then
            MessageBox.Show("Error")
        End If
        wk = "1B""@TEST Image END""0a"
        ret = nii.NiiPrint(Text8.Text, wk, wk.Length, Nothing)
        If ret <> 0 Then
            MessageBox.Show("Error")
        End If
        '󎚌㏈
        wk = "1B4A781b69"
        ret = nii.NiiPrint(Text8.Text, wk, wk.Length, Nothing)
        If ret <> 0 Then
            MessageBox.Show("Error")
        End If
        wk = "1D""G""10"
        ret = nii.NiiPrint(Text8.Text, wk, wk.Length, Nothing)
        If ret <> 0 Then
            MessageBox.Show("Error")
        End If
        ret = nii.NiiEndDoc(Text8.Text)
        If ret <> 0 Then
            MessageBox.Show("Error")
        End If

        '\[XJ
        g.ReleaseHdc(hdc)
        g.Dispose()
    End Sub

    Private Sub timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles timer1.Tick
        Dim i As Long
        Dim st As Long
        Dim ret As Integer
        Dim tm As Long
        Dim dat(64) As Byte

        ret = nii.NiiGetStatus(Text8.Text, st)
        If ret <> 0 Then
            Text2.Text = "Error" + Convert.ToString(ret)
        Else
            Text2.Text = Convert.ToString(st)
        End If
        ret = nii.NiiGetInformation(Text8.Text, 19, dat, tm)
        If ret <> 0 Then
            Text9.Text = "Error" + Convert.ToString(ret)
        End If

        Text9.Text = ""
        Text7.Text = ""
        Text9.Text = Convert.ToString(BitConverter.ToUInt32(dat, 0))
        For i = 4 To 7
            Text7.Text = Text7.Text + dat(i).ToString("X2")
        Next
        Text6.Text = Convert.ToString(tm)
    End Sub

    Private Sub button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button3.Click
        Dim st As Long
        Dim tm As Long
        Dim dat(4) As Byte

        nii.PrinterName = Text8.Text
        dat = BitConverter.GetBytes(nii.NiiGetJobEndInf(st, tm))
        textBox4.Text = Convert.ToString(BitConverter.ToUInt32(dat, 0))
        textBox5.Text = Convert.ToString(st, 16)
        textBox6.Text = Convert.ToString(tm)
    End Sub
End Class
