// Sample8Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Sample8.h"
#include "Sample8Dlg.h"
#include "ImportAPI.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSample8Dlg dialog


//////////////////////////////////////////////////////////////////////////////////////////////
//Mounting PrinterAPI  
//////////////////////////////////////////////////////////////////////////////////////////////
CPrinterAPI	PrinterAPI;

CSample8Dlg::CSample8Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSample8Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSample8Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSample8Dlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDNiiPrint, &CSample8Dlg::OnBnClickedNiiprint)
	ON_BN_CLICKED(IDNiiDPrint, &CSample8Dlg::OnBnClickedNiidprint)
	ON_BN_CLICKED(IDNiiImagePrint, &CSample8Dlg::OnBnClickedNiiimageprint)
	ON_BN_CLICKED(IDNiiBitImagePrint, &CSample8Dlg::OnBnClickedNiiBitimageprint)
	ON_BN_CLICKED(IDNiiImagePrintF, &CSample8Dlg::OnBnClickedNiiimageprintf)
	ON_BN_CLICKED(IDNiiBitImagePrintF, &CSample8Dlg::OnBnClickedNiibitimageprintf)
	ON_BN_CLICKED(IDNiiGetStatus, &CSample8Dlg::OnBnClickedNiigetstatus)
	ON_BN_CLICKED(IDNiiGetInformatino, &CSample8Dlg::OnBnClickedNiigetinformatino)
	ON_BN_CLICKED(IDPractice, &CSample8Dlg::OnBnClickedPractice)
	ON_BN_CLICKED(IDNiiResetPrinter, &CSample8Dlg::OnBnClickedNiiresetprinter)
END_MESSAGE_MAP()


// CSample8Dlg message handlers

BOOL CSample8Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	//////////////////////////////////////////////////////////////////////////////////////////////
	//Load PrinterAPI
	//////////////////////////////////////////////////////////////////////////////////////////////
	if ( PrinterAPI.Initialize() == FALSE ) 
	{
		AfxMessageBox(_T("Error :Load PrinterAPI"));
		return FALSE;
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSample8Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSample8Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CSample8Dlg::OnBnClickedNiiprint()
{
	//!!!! NiiPrint̑1͊eňقȂ܂ 
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"NII ExD NP-3511\"0A",19,NULL);

}

void CSample8Dlg::OnBnClickedNiidprint()
{
BYTE cmd[14];
	cmd[0] = 'H';
	cmd[1] = 'e';
	cmd[2] = 'l';
	cmd[3] = 'l';
	cmd[4] = 'o';
	cmd[5] = ' ';
	cmd[6] = 'P';
	cmd[7] = 'r';
	cmd[8] = 'i';
	cmd[9] = 'n';
	cmd[10] = 't';
	cmd[11] = 'e';
	cmd[12] = 'r';
	cmd[13] = 0x0A;
	//!!!! NiiDPrint̑1͊eňقȂ܂
	PrinterAPI.NiiDPrint("NII ExD NP-3511",cmd,14,NULL);
}

void CSample8Dlg::OnBnClickedNiiimageprint()
{
HDC hdc;
HBITMAP hBitmap;
RECT lprc;
HFONT hFont,hBeforeFont;

	hdc = CreateCompatibleDC(NULL);
	hBitmap = CreateCompatibleBitmap(hdc, 576, 200);
	SelectObject(hdc, hBitmap);

	lprc.left = 0;
	lprc.top = 0;
	lprc.right = 576;
	lprc.bottom = 200;

	FillRect(hdc,&lprc,(HBRUSH)GetStockObject( WHITE_BRUSH ));
	Rectangle( hdc, 0, 50, 575, 150 );     

	hFont = CreateFont(57, 0, 0, 0, FW_NORMAL, FALSE, FALSE, 0,
            SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
            DEFAULT_QUALITY, DEFAULT_PITCH, "Century");
	hBeforeFont = (HFONT)SelectObject(hdc, hFont);
	TextOut(hdc, 2, 65, "NiiImagePrintEx Sample", 22);
	SelectObject(hdc, hBeforeFont);
    DeleteObject(hFont);

	PrinterAPI.NiiImagePrintEx("NII ExD NP-3511",hdc,576,200,true,NULL);
	DeleteDC(hdc);
}

void CSample8Dlg::OnBnClickedNiiBitimageprint()
{
HDC hdc;
HBITMAP hBitmap;
RECT lprc;
HFONT hFont,hBeforeFont;

	hdc = CreateCompatibleDC(NULL);
	hBitmap = CreateCompatibleBitmap(hdc, 576, 200);
	SelectObject(hdc, hBitmap);

	lprc.left = 0;
	lprc.top = 0;
	lprc.right = 576;
	lprc.bottom = 200;

	FillRect(hdc,&lprc,(HBRUSH)GetStockObject( WHITE_BRUSH ));
	Rectangle( hdc, 0, 50, 575, 150 );     

	hFont = CreateFont(56, 0, 0, 0, FW_NORMAL, FALSE, FALSE, 0,
            SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
            DEFAULT_QUALITY, DEFAULT_PITCH, "Century");
	hBeforeFont = (HFONT)SelectObject(hdc, hFont);
	TextOut(hdc, 2, 65, "NiiBitImagePrint Sample", 23);
	SelectObject(hdc, hBeforeFont);
    DeleteObject(hFont);

	PrinterAPI.NiiBitImagePrint("NII ExD NP-3511",hdc,576,200,NULL);
	DeleteDC(hdc);
}

void CSample8Dlg::OnBnClickedNiiimageprintf()
{
	//!!!! NiiImagePrint̑1͊eňقȂ܂
	PrinterAPI.NiiImagePrintF("NII ExD NP-3511","c:\\TEST.BMP",1,NULL);

}

void CSample8Dlg::OnBnClickedNiibitimageprintf()
{
	//!!!! NiiImagePrint̑1͊eňقȂ܂
	PrinterAPI.NiiImagePrintF("NII ExD NP-3511","c:\\TEST.BMP",1,NULL);
}

void CSample8Dlg::OnBnClickedNiigetstatus()
{
int ret;
DWORD st;
	//!!!! NiiGetStatus̑1͊eňقȂ܂
	ret = PrinterAPI.NiiGetStatus("NII ExD NP-3511",&st);
	//ڑ󋵃`FbN
	if(ret == -5)
	{
		AfxMessageBox(_T("Printer OFFLINE"));
	}
	else if(ret < -100)
	{
		AfxMessageBox(_T("Printer Service Error"));
	}
	else if(ret < 0)
	{
		AfxMessageBox(_T("Communication Error"));
	}
	//v^ԃ`FbN
	if((st & 0x01) > 0)
	{
		AfxMessageBox(_T("Paper Near End"));
	}
	if((st & 0x02) > 0)
	{
		AfxMessageBox(_T("Head Open"));
	}
	if((st & 0x04) > 0)
	{
		AfxMessageBox(_T("Paper End"));
	}
	if((st & 0xF8) > 0)
	{
		AfxMessageBox(_T("Other Error"));
	}
	if(st == 0)
		AfxMessageBox(_T("Ready"),MB_ICONINFORMATION);


}

void CSample8Dlg::OnBnClickedNiigetinformatino()
{
int ret;
char prtname[64];
DWORD tm;
DWORD htm;

	//ݏԎ擾
	//!!!! NiiGetInformation̑1͊eňقȂ܂
	ret = PrinterAPI.NiiGetInformation("NII ExD NP-3511",2,prtname,&tm);
	htm = tm;

	//v^擾vs
	//!!!! NiiGetStatus̑1͊eňقȂ܂
	PrinterAPI.NiiPrint("NII ExD NP-3511","1B7302",6,NULL);

	//M҂
	while(htm == tm)
	{
		//!!!! NiiGetInformation̑1͊eňقȂ܂
		ret = PrinterAPI.NiiGetInformation("NII ExD NP-3511",2,prtname,&tm);
		//ڑ󋵃`FbN
		if(ret != 0)
		{
			AfxMessageBox(_T("Get Error"));
			return;
		}
	}
	AfxMessageBox(prtname,MB_ICONINFORMATION);
}

void CSample8Dlg::OnBnClickedPractice()
{
int ret;
DWORD st;
BYTE prtinf[64];
DWORD tm;
DWORD htm;
DWORD JOBID;

DWORD wk;

char szCommand[256];   //o̓f[^i[GA

	//ݏ󋵊mF
	ret = PrinterAPI.NiiGetStatus("NII ExD NP-3511",&st);
	//ڑ󋵃`FbN
	if(ret == -5)
	{
		AfxMessageBox(_T("Printer OFFLINE"));
		return;
	}
	else if(ret < -100)
	{
		AfxMessageBox(_T("Printer Service Error"));
		return;
	}
	else if(ret < 0)
	{
		AfxMessageBox(_T("Communication Error"));
		return;
	}
	//v^ԃ`FbN
	if((st & 0x02) > 0)
	{
		AfxMessageBox(_T("Head Open"));
		return;
	}
	if((st & 0x04) > 0)
	{
		AfxMessageBox(_T("Paper End"));
		return;
	}
	if((st & 0xF8) > 0)
	{
		AfxMessageBox(_T("Other Error"));
		return;
	}

RETRY:

	ret = PrinterAPI.NiiGetInformation("NII ExD NP-3511",19,prtinf,&tm);			//݈󎚊ʒmԎ擾
	htm = tm;
	ret = PrinterAPI.NiiStartDoc("NII ExD NP-3511",&JOBID);						//hLgJn
	if(ret != 0)
	{	
		AfxMessageBox(_T("Error:StartDoc"));
		return;
	}
	//󎚊Jn錾(GS G 11)R}h
	sprintf(szCommand,"1D4711\"");
	memcpy(&szCommand[7],&JOBID,4);
	szCommand[11] = '\"';
	PrinterAPI.NiiPrint("NII ExD NP-3511",szCommand,12,NULL);					//󎚊Jn錾(GS G 11)R}hs
	PrinterAPI.NiiPrint("NII ExD NP-3511","1D\"P\"001B\"J\"08",strlen("1D\"P\"001B\"J\"08"),NULL);	//NVC[WR}h,R}hs
	//󎚃f[^MiV[gj
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Part Name          Num       Price     SubTotal\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"-----------------------------------------------\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Paper                2          60          120\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Pencil               1         100          100\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Eraser               1          90           90\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Note                 1          80           80\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Book                 1         500          500\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Calendar             1        1200         1200\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Rule                 1         120          120\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Calculator           1        3980         3980\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Bookends             1          90           90\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Stapler              1         110          110\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Pen(black)           1          70           70\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Pen(red)             1          70           70\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Pen(blue)            1          70           70\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Pen(yellow)          1          70           70\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Pen(green)           1          70           70\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Pen(pink)            1          70           70\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Pen(Purple)          1          70           70\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"Scissors             1         200          200\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"-----------------------------------------------\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","\"                                    Total 7,080\"0a", 51,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","1B\"J\"68",strlen("1B\"J\"68"),NULL);	//R}hs(Jbgʒu܂ňړj
	PrinterAPI.NiiPrint("NII ExD NP-3511","1B\"m\"",strlen("1B\"m\""),NULL);		//JbgR}hs
	
	//󎚃f[^Miij
	PrinterAPI.NiiImagePrintF("NII ExD NP-3511","c:\\GIFT_Certificate.bmp",1,NULL);
	PrinterAPI.NiiPrint("NII ExD NP-3511","1B\"J\"97",strlen("1B\"J\"97"),NULL);	//R}hs(Jbgʒu܂ňړj
	PrinterAPI.NiiPrint("NII ExD NP-3511","1B\"m\"",strlen("1B\"m\""),NULL);		//JbgR}hs

	PrinterAPI.NiiPrint("NII ExD NP-3511","1D4710",6,NULL);						//󎚊錾(GS G 10)R}hs
	PrinterAPI.NiiEndDoc("NII ExD NP-3511");

RETRYWAIT:
	//M҂
	while(htm == tm)
	{
		ret = PrinterAPI.NiiGetInformation("NII ExD NP-3511",19,prtinf,&tm);
		//ڑ󋵃`FbN
		if(ret != 0)
		{
			AfxMessageBox(_T("Get Error"));
			return;
		}
	}

	memcpy(&wk,prtinf,4);
	if(JOBID == wk)
	{
		memcpy(&wk,&prtinf[4],4);
		if(wk != 0)
		{
			AfxMessageBox("Failed to Print!!",MB_ICONINFORMATION);
			goto RETRY;
		}
	}
	else
	{
		htm = tm;
		goto RETRYWAIT;
	}
		 
	AfxMessageBox("FINISH!!",MB_ICONINFORMATION);
}

void CSample8Dlg::OnBnClickedNiiresetprinter()
{
int ret;
	ret = PrinterAPI.NiiResetPrinter("NII ExD NP-3511");
	//G[`FbN
	if(ret != 0)
	{
		AfxMessageBox(_T("Reset Error"));
		return;
	}
	AfxMessageBox(_T("Reset Success"));
}
