using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;
using System.Drawing.Printing;

namespace Sample4
{
    public partial class Form1 : Form
    {
        //DLLC|[g
        [DllImport("gdi32.dll", EntryPoint = "CreateFont")]
        private static extern IntPtr CreateFont(int nHeight,	/* tHg̘_	*/
                                             int nWidth,	/* ̘_ϕ	*/
                                             int nEscapement,	/* eLXgs̊px	*/
                                             int nOrientation,	/* x[X Cx̊px	*/
                                             int fnWeight,	/* tHg̑	*/
                                             uint fdwItalic,	/* C^bN̑̃tO	*/
                                             uint fdwUnderline,	/* t̃tO	*/
                                             uint fdwStrikeOut,	/* łt̃tO	*/
                                             uint fdwCharSet,	/* Zbgʎq	*/
                                             uint fdwOutputPrecision,	/* o͐x	*/
                                             uint fdwClipPrecision,	/* NbsOx	*/
                                             uint fdwQuality,	/* o͕i	*/
                                             uint fdwPitchAndFamily,	/* sb`ƃt@~	*/
                                             [MarshalAs(UnmanagedType.LPStr)] string lpszFace	/* ^CvtFCX̃AhX	*/
                                            );
        [DllImport("gdi32.dll", EntryPoint = "SelectObject")]
        private static extern IntPtr SelectObject(IntPtr hdc, /* foCX ReLXg̃nh	*/
                                               IntPtr hgdiobj  /* IuWFNg̃nh	*/
                                              );
        [DllImport("gdi32.dll", EntryPoint = "DeleteObject")]
        private static extern bool DeleteObject(IntPtr hgdiobj  /* OtBbN IuWFNg̃nh */
                                              );
        [DllImport("gdi32.dll", EntryPoint = "TextOut")]
        private static extern bool TextOut(IntPtr hdc,	/* foCX ReLXg̃nh	*/
                                          int nXStart,	/* JnʒuxW	*/
                                          int nYStart,	/* JnʒuyW	*/
                                           string lpString,	/* ̃AhX	*/
                                          int cbString	/* ̐̕	*/
                                         );
        
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            PrintDocument pd = new PrintDocument();
            pd.PrintPage += new PrintPageEventHandler(this.pd_PrintPage);

            pd.PrinterSettings.PrinterName = "SII RP-B10";
            pd.Print();

        }
        // The PrintPage event is raised for each page to be printed.
        private void pd_PrintPage(object sender, PrintPageEventArgs ev)
        {
            IntPtr hdc;
            IntPtr hFont, hBeforeFont;
            string wout;
            Font printFont;
            Encoding sjisEnc = Encoding.GetEncoding("Shift_JIS");
            int num;

            hdc = ev.Graphics.GetHdc();                     //Get Device Context
            hFont = CreateFont(                             //Create Font
                            12, 0,// tHg,
                            0,
                            0,
                            400,
                            0,
                            0,
                            0,
                            128,    //SHIFTJIS_CHARSET
                            0,      //OUT_DEFAULT_PRECIS
                            0,      //CLIP_DEFAULT_PRECIS
                            2,      //PROOF_QUALITY
                            49,     //FIXED_PITCH | FF_MODERN
                            "IPD Font A Japanese" //Font name
                            );
            hBeforeFont = SelectObject(hdc, hFont);

            //Output
            wout = "HELLO Device Font";
            num = sjisEnc.GetByteCount(wout);
            TextOut(hdc, 0, 0, wout, num);
            SelectObject(hdc, hBeforeFont);
            DeleteObject(hFont);
            ev.HasMorePages = false;
        }
    }
}