// Sample7Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Sample7.h"
#include "Sample7Dlg.h"
#include "ImportApiEx.h"
#include "winspool.h"
#include <stdio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSample7Dlg dialog

////////////////////////////////////////////////        
//Mounting EmuPrinterAPI  
////////////////////////////////////////////////
CEmuPrinterAPI	EmuPrinterAPI;

CSample7Dlg::CSample7Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSample7Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSample7Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSample7Dlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDPrint, &CSample7Dlg::OnBnClickedPrint)
	ON_BN_CLICKED(IDGETPROPERTY, &CSample7Dlg::OnBnClickedGetproperty)
END_MESSAGE_MAP()


// CSample7Dlg message handlers

BOOL CSample7Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	if ( EmuPrinterAPI.Initialize() == FALSE ) 
	{
		AfxMessageBox(_T("Error :Load PrinterAPI"));
		return FALSE;
	}


	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSample7Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSample7Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CSample7Dlg::OnBnClickedPrint()
{
HDC hdc;
DOCINFO docinfo; 
TEXTMETRIC textmetric;
int wk;
HFONT hFont,hBeforeFont;

HANDLE hPrn;
DEVMODE        *devmode;
unsigned char* buff_dev = NULL;
LONG  devSize;

BYTE setdat[8];

FILE *fp;

	memset(&docinfo, 0, sizeof(DOCINFO));
	docinfo.cbSize = sizeof(DOCINFO);
	docinfo.lpszDocName = "testprint"; 

	//!!!! CreateDC̈͊eňقȂ܂ NII IPD NP-T318
	hdc = CreateDC("SII RP-B10", "SII RP-B10", NULL, NULL); 
    if(OpenPrinter("SII RP-B10", &hPrn, NULL) )
    {
        //DEVMODE\ TCY擾̈搶
        devSize  = DocumentProperties(NULL, hPrn, NULL, NULL, NULL, 0);
        buff_dev = new unsigned char[devSize];
        devmode  = (DEVMODE*)buff_dev;
        //擾
        DocumentProperties(NULL,
                           hPrn,
                           NULL,
                           devmode,
                           NULL,
                           DM_IN_BUFFER | DM_OUT_BUFFER);
	}
	ClosePrinter(hPrn);

	fp = fopen("d:\\testdmb.bin","w");
	fwrite(devmode,devSize,1,fp);
	fclose(fp);

	EmuPrinterAPI.EmuDM_SetProperty(devmode,68,NULL,0);		//ݒ
	setdat[0] = 3;											//y[WJnhAI[vi2PINj
	EmuPrinterAPI.EmuDM_SetProperty(devmode,10,setdat,1);
	ResetDC(hdc,devmode);

	fp = fopen("d:\\testdm.bin","w");
	fwrite(devmode,devSize,1,fp);
	fclose(fp);

	StartDoc(hdc, &docinfo);	
	//***********************************************
	//************** V[g@******************
	//***********************************************
	//vpeBlύX
	setdat[0] = 3;
	EmuPrinterAPI.EmuDM_SetProperty(devmode,50,setdat,1);	//80mmp
	setdat[0] = 1;											//y[WJnhAI[vi2PINj
	EmuPrinterAPI.EmuDM_SetProperty(devmode,22,setdat,1);
	strcpy((PCHAR)&setdat[0],"1D\"P\"00");					//y[WJnSiPattern0)
	EmuPrinterAPI.EmuDM_SetProperty(devmode,25,setdat,8);
	setdat[0] = 1;											//y[WIJb^[ip[VJbgj
	EmuPrinterAPI.EmuDM_SetProperty(devmode,31,setdat,1);
	setdat[0] = 1;											//y[WIJb^[ʒu܂ňړ
	EmuPrinterAPI.EmuDM_SetProperty(devmode,39,setdat,1);



	//ύXDevModeŃfoCXReLXgĐݒ
	ResetDC(hdc,devmode);

	StartPage(hdc);

	hFont = CreateFont(                             
                            12, 0,// tHg,(gptHgɕς܂j
                            0,
                            0,
                            400,
                            0,
                            0,
                            0,
							//Zbg̎ʎqi0:ANSI_CHARSET@128:SHIFTJIS_CHARSET
                            128,    //SHIFTJIS_CHARSET(gptHgɕς܂j
                            0,      //OUT_DEFAULT_PRECIS
                            0,      //CLIP_DEFAULT_PRECIS
                            2,      //PROOF_QUALITY
                            49,     //FIXED_PITCH | FF_MODERN
                            "IPD Font A Japanese" //Font name
                            );
    hBeforeFont = (HFONT)SelectObject(hdc, hFont);

	GetTextMetrics(hdc, &textmetric);
	TextOut(hdc, 10, textmetric.tmHeight * 1,  "Part Name          Num       Price     SubTotal", 47);
	TextOut(hdc, 10, textmetric.tmHeight * 2,  "-----------------------------------------------", 47);
	wk = textmetric.tmHeight *2;
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "Paper                2          60          120", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "Pencil               1         100          100", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "Eraser               1          90           90", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "Note                 1          80           80", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "Book                 1         500          500", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "Calendar             1        1200         1200", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "Rule                 1         120          120", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "Calculator           1        3980         3980", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "Bookends             1          90           90", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "Stapler              1         110          110", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "Pen(black)           1          70           70", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "Pen(red)             1          70           70", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "Pen(blue)            1          70           70", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "Pen(yellow)          1          70           70", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "Pen(green)           1          70           70", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "Pen(pink)            1          70           70", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "Pen(Purple)          1          70           70", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "Scissors             1         200          200", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "-----------------------------------------------", 47);
	TextOut(hdc, 10, wk+= textmetric.tmHeight, "                                    Total 7,080", 47);
	SelectObject(hdc, hFont);
	EndPage(hdc);

	//***********************************************
	//************** Mtg@******************
	//***********************************************
	//vpeBlύX
	EmuPrinterAPI.EmuDM_SetProperty(devmode,63,NULL,0);		//80mm`Pbgݒ
	devmode->dmOrientation = DMORIENT_LANDSCAPE;			//̌ij
	setdat[0] = 96;											//y[WItB[hi96dotj
	EmuPrinterAPI.EmuDM_SetProperty(devmode,37,setdat,1);
	//ύXDevModeŃfoCXReLXgĐݒ
	ResetDC(hdc,devmode);

	//̈J
	if(buff_dev != NULL)
		delete[] buff_dev;

	StartPage(hdc);

	hFont = CreateFont(40, 0, 0, 0, FW_NORMAL, FALSE, FALSE, 0,
            SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
            DEFAULT_QUALITY, DEFAULT_PITCH, "Century");
    hBeforeFont = (HFONT)SelectObject(hdc, hFont);
	GetTextMetrics(hdc, &textmetric);
	TextOut(hdc, 10, textmetric.tmHeight * 1, "Gift certificate", 16);
	TextOut(hdc, 10, textmetric.tmHeight * 2, 
		"----------------------------------------", 40);

	wk = textmetric.tmHeight *4;
	wk+= textmetric.tmHeight;
	TextOut(hdc, 260, wk+= textmetric.tmHeight, "        \\2,000-", 15);
	TextOut(hdc, 260, wk+= textmetric.tmHeight, "---------------", 15);

	wk+= textmetric.tmHeight;
	wk+= textmetric.tmHeight;
	wk+= textmetric.tmHeight;
	wk+= textmetric.tmHeight;
	TextOut(hdc, 250, wk+= textmetric.tmHeight, "Expiration date:2010/09/30", 26);
	TextOut(hdc, 250, wk+= textmetric.tmHeight, "ABC shop", 8);

	SelectObject(hdc, hBeforeFont);
	EndPage(hdc);
	EndDoc(hdc);
	DeleteDC(hdc);
}

void CSample7Dlg::OnBnClickedGetproperty()
{
HANDLE hPrn;
DEVMODE        *devmode;
unsigned char* buff_dev = NULL;
LONG  devSize;

BYTE *wk;
DWORD dsize;

char msg[1024];

    if(OpenPrinter("NII IPD NP-T318", &hPrn, NULL) )
    {
        //DEVMODE\ TCY擾̈搶
        devSize  = DocumentProperties(NULL, hPrn, NULL, NULL, NULL, 0);
        buff_dev = new unsigned char[devSize];
        devmode  = (DEVMODE*)buff_dev;
        //擾
        DocumentProperties(NULL,
                           hPrn,
                           NULL,
                           devmode,
                           NULL,
                           DM_IN_BUFFER | DM_OUT_BUFFER);
	}
	ClosePrinter(hPrn);

	EmuPrinterAPI.EmuDM_GetProperty(devmode,0,NULL,&dsize);
	wk = (PBYTE)malloc(dsize);
	EmuPrinterAPI.EmuDM_GetProperty(devmode,0,wk,&dsize);

	sprintf(msg,"All Image = %d",wk[0]);
	AfxMessageBox(_T(msg));

	free(wk);
	delete(devmode);
}
